CcdCommitmentsClient¶
-
class
oci.ccd_offers.CcdCommitmentsClient(config, **kwargs)¶ Use the Continuous Consumption Discounts API to manage continuous consumption discount operations.
Methods
__init__(config, **kwargs)Creates a new service client create_ccd_commitment(ccd_offer_id, …)Request to create a new CCD commitment. delete_ccd_commitment(ccd_commitment_id, …)Terminates the CCD commitment. get_ccd_commitment(ccd_commitment_id, **kwargs)Gets the CCD commitment using the CCD commitment ID. list_ccd_commitments(subscription_id, …)Lists the CCD commitments. update_ccd_commitment(ccd_commitment_id, …)Updates the free-form tags, defined tags, or both on a CCD commitment. -
__init__(config, **kwargs)¶ Creates a new service client
Parameters: - config (dict) – Configuration keys and values as per SDK and Tool Configuration.
The
from_file()method can be used to load configuration from a file. Alternatively, adictcan be passed. You can validate_config the dict usingvalidate_config() - service_endpoint (str) – (optional)
The endpoint of the service to call using this client. For example
https://iaas.us-ashburn-1.oraclecloud.com. If this keyword argument is not provided then it will be derived using the region in the config parameter. You should only provide this keyword argument if you have an explicit need to specify a service endpoint. - timeout (float or tuple(float, float)) – (optional) The connection and read timeouts for the client. The default values are connection timeout 10 seconds and read timeout 60 seconds. This keyword argument can be provided as a single float, in which case the value provided is used for both the read and connection timeouts, or as a tuple of two floats. If a tuple is provided then the first value is used as the connection timeout and the second value as the read timeout.
- signer (
AbstractBaseSigner) –(optional) The signer to use when signing requests made by the service client. The default is to use a
Signerbased on the values provided in the config parameter.One use case for this parameter is for Instance Principals authentication by passing an instance of
InstancePrincipalsSecurityTokenSigneras the value for this keyword argument - retry_strategy (obj) –
(optional) A retry strategy to apply to all calls made by this service client (i.e. at the client level). There is no retry strategy applied by default. Retry strategies can also be applied at the operation level by passing a
retry_strategykeyword argument as part of calling the operation. Any value provided at the operation level will override whatever is specified at the client level.This should be one of the strategies available in the
retrymodule. A convenienceDEFAULT_RETRY_STRATEGYis also available. The specifics of the default retry strategy are described here. - circuit_breaker_strategy (obj) – (optional)
A circuit breaker strategy to apply to all calls made by this service client (i.e. at the client level).
This client uses
DEFAULT_CIRCUIT_BREAKER_STRATEGYas default if no circuit breaker strategy is provided. The specifics of circuit breaker strategy are described here. - circuit_breaker_callback (function) – (optional) Callback function to receive any exceptions triggerred by the circuit breaker.
- client_level_realm_specific_endpoint_template_enabled (bool) – (optional) A boolean flag to indicate whether or not this client should be created with realm specific endpoint template enabled or disable. By default, this will be set as None.
- allow_control_chars – (optional) allow_control_chars is a boolean to indicate whether or not this client should allow control characters in the response object. By default, the client will not allow control characters to be in the response object.
- enable_strict_url_encoding – (optional) enable_strict_url_encoding is a boolean to indicate whether or not this client should enable strict url encoding in path params of a request. By default, the client will not enable strict url encoding
- config (dict) – Configuration keys and values as per SDK and Tool Configuration.
The
-
create_ccd_commitment(ccd_offer_id, create_ccd_commitment_details, **kwargs)¶ Request to create a new CCD commitment.
Parameters: - ccd_offer_id (str) – (required) CCD offer OCID. If you’re trying to commit against the CCD offer, ensure that the CCD offer’s lifecycleDetails field value is Current or Scheduled. You can only sign up for a current or scheduled CCD offer, but not for any canceled, or ended CCD offer.
- create_ccd_commitment_details (oci.ccd_offers.models.CreateCcdCommitmentDetails) – (required) The create CCD commitment details model.
- opc_retry_token (str) – (optional) A token that uniquely identifies a request so it can be retried in case of a timeout or server error without risk of executing that same action again.
- opc_request_id (str) – (optional) Unique Oracle-assigned identifier for the request. If you need to contact Oracle about a particular request, please provide the request ID.
- retry_strategy (obj) –
(optional) A retry strategy to apply to this specific operation/call. This will override any retry strategy set at the client-level.
This should be one of the strategies available in the
retrymodule. This operation usesDEFAULT_RETRY_STRATEGYas default if no retry strategy is provided. The specifics of the default retry strategy are described here.To have this operation explicitly not perform any retries, pass an instance of
NoneRetryStrategy. - allow_control_chars (bool) – (optional) allow_control_chars is a boolean to indicate whether or not this request should allow control characters in the response object. By default, the response will not allow control characters in strings
- enable_strict_url_encoding (bool) – (optional) enable_strict_url_encoding is a boolean to indicate whether or not this request should enable strict url encoding for path params. By default, strict url encoding for path params is disabled
Returns: A
Responseobject with data of typeCcdCommitmentReturn type: Example: Click here to see an example of how to use create_ccd_commitment API.
-
delete_ccd_commitment(ccd_commitment_id, **kwargs)¶ Terminates the CCD commitment. You can’t terminate an already canceled or ended commitment. If the CCD commitment has already started based on timeCcdCommitmentStarts, then you can only terminate within a week of its effective timeCcdCommitmentStarts time.
Parameters: - ccd_commitment_id (str) – (required) CCD commitment OCID.
- opc_request_id (str) – (optional) Unique Oracle-assigned identifier for the request. If you need to contact Oracle about a particular request, please provide the request ID.
- if_match (str) – (optional) For optimistic concurrency control. In the PUT or DELETE call for a resource, set the if-match parameter to the value of the etag from a previous GET or POST response for that resource. The resource is updated or deleted only if the etag you provide matches the resource’s current etag value.
- retry_strategy (obj) –
(optional) A retry strategy to apply to this specific operation/call. This will override any retry strategy set at the client-level.
This should be one of the strategies available in the
retrymodule. This operation usesDEFAULT_RETRY_STRATEGYas default if no retry strategy is provided. The specifics of the default retry strategy are described here.To have this operation explicitly not perform any retries, pass an instance of
NoneRetryStrategy. - allow_control_chars (bool) – (optional) allow_control_chars is a boolean to indicate whether or not this request should allow control characters in the response object. By default, the response will not allow control characters in strings
- enable_strict_url_encoding (bool) – (optional) enable_strict_url_encoding is a boolean to indicate whether or not this request should enable strict url encoding for path params. By default, strict url encoding for path params is disabled
Returns: A
Responseobject with data of type NoneReturn type: Example: Click here to see an example of how to use delete_ccd_commitment API.
-
get_ccd_commitment(ccd_commitment_id, **kwargs)¶ Gets the CCD commitment using the CCD commitment ID.
Parameters: - ccd_commitment_id (str) – (required) CCD commitment OCID.
- opc_request_id (str) – (optional) Unique Oracle-assigned identifier for the request. If you need to contact Oracle about a particular request, please provide the request ID.
- retry_strategy (obj) –
(optional) A retry strategy to apply to this specific operation/call. This will override any retry strategy set at the client-level.
This should be one of the strategies available in the
retrymodule. This operation usesDEFAULT_RETRY_STRATEGYas default if no retry strategy is provided. The specifics of the default retry strategy are described here.To have this operation explicitly not perform any retries, pass an instance of
NoneRetryStrategy. - allow_control_chars (bool) – (optional) allow_control_chars is a boolean to indicate whether or not this request should allow control characters in the response object. By default, the response will not allow control characters in strings
- enable_strict_url_encoding (bool) – (optional) enable_strict_url_encoding is a boolean to indicate whether or not this request should enable strict url encoding for path params. By default, strict url encoding for path params is disabled
Returns: A
Responseobject with data of typeCcdCommitmentReturn type: Example: Click here to see an example of how to use get_ccd_commitment API.
-
list_ccd_commitments(subscription_id, compartment_id, **kwargs)¶ Lists the CCD commitments.
Parameters: - subscription_id (str) – (required) The subscription ID associated with the CCD offer.
- compartment_id (str) – (required) The OCID of the compartment (remember that the tenancy is simply the root compartment).
- opc_request_id (str) – (optional) Unique Oracle-assigned identifier for the request. If you need to contact Oracle about a particular request, please provide the request ID.
- page (str) – (optional) The value of the opc-next-page response header from the previous “List” call.
- limit (int) – (optional) The maximum number of items to return in a paginated “List” call.
- lifecycle_state (str) –
(optional) The lifecycle of a CCD commitment that’s being requested, which always defaults to Active. If you want to filter by scheduled, current, awaiting provisioning, canceled, or ended, use the lifecycleDetails query parameter.
Allowed values are: “ACTIVE”
- lifecycle_details (str) –
(optional) The lifecycle details of a CCD commitment that’s being requested. The accepted values are Scheduled, Current, Awaiting Provisioning, Canceled, or Ended. If a null or empty value is passed, it will return for all resources.
Allowed values are: “CURRENT”, “ENDED”, “CANCELED”, “SCHEDULED”, “AWAITING_PROVISIONING”
- source_type (str) –
(optional) Filter CCD offers or commitments by the commercial workflow that created the associated offer.
Allowed values are: “CONTRACT_COMMITMENT”, “CONTRACT_OFFER”, “FLEX”, “OCI_GENERATED”
- sort_order (str) –
(optional) The sort order to use, whether “asc” or “desc”. By default, it is ascending.
Allowed values are: “ASC”, “DESC”
- display_name (str) – (optional) Filter by the resource display name.
- sort_by (str) –
(optional) The sort by field to use, whether “DISPLAYNAME” or “TIMECREATED”. By default, it is TIMECREATED.
Allowed values are: “DISPLAYNAME”, “TIMECREATED”
- retry_strategy (obj) –
(optional) A retry strategy to apply to this specific operation/call. This will override any retry strategy set at the client-level.
This should be one of the strategies available in the
retrymodule. This operation usesDEFAULT_RETRY_STRATEGYas default if no retry strategy is provided. The specifics of the default retry strategy are described here.To have this operation explicitly not perform any retries, pass an instance of
NoneRetryStrategy. - allow_control_chars (bool) – (optional) allow_control_chars is a boolean to indicate whether or not this request should allow control characters in the response object. By default, the response will not allow control characters in strings
- enable_strict_url_encoding (bool) – (optional) enable_strict_url_encoding is a boolean to indicate whether or not this request should enable strict url encoding for path params. By default, strict url encoding for path params is disabled
Returns: A
Responseobject with data of typeCcdCommitmentCollectionReturn type: Example: Click here to see an example of how to use list_ccd_commitments API.
-
update_ccd_commitment(ccd_commitment_id, update_ccd_commitment_details, **kwargs)¶ Updates the free-form tags, defined tags, or both on a CCD commitment. Commercial commitment attributes are immutable.
Parameters: - ccd_commitment_id (str) – (required) CCD commitment OCID.
- update_ccd_commitment_details (oci.ccd_offers.models.UpdateCcdCommitmentDetails) – (required) The tag update details.
- opc_request_id (str) – (optional) Unique Oracle-assigned identifier for the request. If you need to contact Oracle about a particular request, please provide the request ID.
- if_match (str) – (optional) For optimistic concurrency control. In the PUT or DELETE call for a resource, set the if-match parameter to the value of the etag from a previous GET or POST response for that resource. The resource is updated or deleted only if the etag you provide matches the resource’s current etag value.
- retry_strategy (obj) –
(optional) A retry strategy to apply to this specific operation/call. This will override any retry strategy set at the client-level.
This should be one of the strategies available in the
retrymodule. This operation usesDEFAULT_RETRY_STRATEGYas default if no retry strategy is provided. The specifics of the default retry strategy are described here.To have this operation explicitly not perform any retries, pass an instance of
NoneRetryStrategy. - allow_control_chars (bool) – (optional) allow_control_chars is a boolean to indicate whether or not this request should allow control characters in the response object. By default, the response will not allow control characters in strings
- enable_strict_url_encoding (bool) – (optional) enable_strict_url_encoding is a boolean to indicate whether or not this request should enable strict url encoding for path params. By default, strict url encoding for path params is disabled
Returns: A
Responseobject with data of typeCcdCommitmentReturn type: Example: Click here to see an example of how to use update_ccd_commitment API.
-